                       
                                
                            
                                    
                                    
                           

                       
                                   
  Dyno's phones:           Sources code
  +54-1-5222422                             WORLD HQ
  +54-1-PRIVATE                           -  -
    Full 24hs          


                ; Source Code By Richie++
                ;               4:900/208.2@fidonet.org
                ;               postmaster@gricha.recom.edu.ar
                ;               Dyno's BBS: +54-1-522-2422
                ;       Write me, for anything...
                ;


        .model tiny
        .code
        .386
        locals
        org     100h

begin:
        jmp     start

DisX    dw      0
DisY    dw      0                       ; 3D   Origin
DisZ    dw      300

RealDisX        EQU     0
RealDisY        EQU     100              ; 3D Displacement (for easy testing)
RealDisZ        EQU     0

Sin     EQU     31                      ; Fixed Sin&Cos for angle = 7
Cos     EQU     254                     ; You can change it or use a table
                                        ; for real time angle change.

CantPoints      EQU     1000            ; Number of 3D points

                                        ; 3D points array: (X,Y,Z),(X,Y,Z)...
COMMENT |
Points  LABEL
        DW      -50,50,-50
        DW      -50,-50,-50
        DW      50,50,-50
        DW      50,-50,-50

        DW      -50,50,50
        DW      -50,-50,50
        DW      50,50,50
        DW      50,-50,50

        DW      -50,50,0
        DW      -50,-50,0
        DW      50,50,0
        DW      50,-50,0

        DW      0,50,-50
        DW      0,-50,-50
        DW      0,50,50
        DW      0,-50,50

        DW      -50,0,-50
        DW      50,0,-50
        DW      -50,0,50
        DW      50,0,50

        DW      -50 ,0  ,0
        DW      0,0  ,-50
        DW      0,0  ,50
        DW      0,-50,0
        DW      0,50 ,0
        DW      50,0  ,0
|

Seed    db      'Sdgf876tgf3-'

Random  PROC
        mov     bp,cx
        mov     cx,8
        mov     bx,offset Seed+16
        in      ax,40h
        xor     ax,word ptr ds:[bx]
        push    ax
a_loop:
        mov     ax,word ptr [bx-2]
        adc     word ptr [bx],ax
        dec     bx
        dec     bx
        loop    a_loop
        mov     ax,dx
        pop     dx
        adc     word ptr [bx],dx
        mov     dx,word ptr [bx]
        mov     bx,ax
        add     ax,ax
        mul     dx
        sub     dx,bx
        mov     ax,dx
        mov     cx,bp
        retn
ENDP
        

SetUp   PROC                            ; Add 3D displacement for testing
@@Loop_Here:
        add     word ptr [si],RealDisX
        add     word ptr [si+2],RealDisY
        add     word ptr [si+4],RealDisZ
        add     si,6
        loop    @@Loop_Here
        ret
ENDP

Show    PROC                            ; Show points.
                                        ; write to 4 VGA's planes: Color is 0Fh
@@Loop_Here:
        push    cx
        lodsw                   ; AX = 3D X
        add     ax,DisX         ; AX = 3D X+DispX
        mov     bp,ax           ; BP = 3D X+DispX
        lodsw                   ; AX = 3D Y
        add     ax,DisY         ; AX = 3D Y+DispY
        mov     cx,ax           ; CX = 3D Y+DispY
        lodsw                   ; AX = 3D Z
        add     ax,DisZ         ; AX = 3D Z+DispZ

        js      @@Do_Loop
        or      ax,ax
        jne     @@No_0
        inc     ax
@@No_0:


        xchg    cx,ax           ; CX = 3D Z+DispZ | AX = 3D Y+DispY
        cwd
        shld    dx,ax,8         ; DX:AX=Y*256
        shl     ax,8
        idiv    cx              ; AX = Y*256/Z
        add     ax,240d         ; AX = Y*256/Z+240d (240d is 2D Y Center)
        cmp     ax,480d         ; (480d is 2D Y Max)
        jg      @@Do_Loop       ; Out of Screen

        imul    ax,80d          ; DX:AX = YS*80d
        mov     di,ax

        mov     ax,bp           ; AX = X
        cwd
        shld    dx,ax,8
        shl     ax,8            ; AX = X*256
        idiv    cx              ; AX = X*256/Z
        add     ax,300d         ; AX = X*256/Z+300      (300d is 2D X Center)
        cmp     ax,640d         ; (640d is 2D X Max)
        jg      @@Do_Loop       ; Out of Screen
        mov     cl,al
        shr     ax,3
        add     di,ax           ; Add #text column
        mov     al,80h
        and     cl,07h
        shr     al,cl           ; Just a pixel
        or      byte ptr es:[di],al
@@Do_Loop:
        pop     cx
        Loop    @@Loop_Here
        ret
ENDP

Clear   PROC
@@Loop_Here:
        push    cx
        lodsw
        add     ax,DisX
        mov     bp,ax           ; BP = X
        lodsw
        add     ax,DisY
        mov     cx,ax           ; CX = Y
        lodsw
        add     ax,DisZ

        js      @@Do_Loop
        or      ax,ax
        jne     @@No_0
        inc     ax
@@No_0:

        xchg    cx,ax           ; CX = Z | AX = Y
        cwd
        shld    dx,ax,8         ; DX:AX=Y*256
        shl     ax,8
        idiv    cx              ; AX = Y*256/Z
        add     ax,240d         ; AX = Y*256/Z+100
        cmp     ax,480d
        jg      @@Do_Loop       ; Out of Screen

        imul    ax,80d          ; DX:AX = YS*80d
        mov     di,ax

        mov     ax,bp           ; AX = X
        cwd
        shld    dx,ax,8
        shl     ax,8            ; AX = X*256
        idiv    cx              ; AX = X*256/Z
        add     ax,300d         ; AX = X*256/Z+160
        cmp     ax,640d
        jg      @@Do_Loop       ; Out of Screen
        mov     cl,al
        shr     ax,3
        add     di,ax           ; Add #text column
        mov     al,7fh
        ror     al,cl           ; Just a pixel
        and     byte ptr es:[di],al
@@Do_Loop:
        pop     cx
        Loop    @@Loop_Here
        ret
ENDP


       ; SI = offset (x,y,z) array      ; Y'=cos(a)*y - sin(a)*z
       ; CX = Count                     ; Z'=sin(a)*y + cos(a)*z

RotX    PROC
@@Loop_Here:
        add     si,2
        lodsw
        cwde
        mov     ebx,eax         ; BX = Y
        lodsw                   ; AX = Z
        cwde
        imul    edx,ebx,Cos     ; EDX = Y*Cos
        imul    ebp,eax,Sin     ; EBP = Z*Sin
        sub     edx,ebp         ; EDX = Y*Cos - Z*Sin = NewY

        imul    ebx,ebx,Sin     ; BX = Y*Sin
        imul    eax,eax,Cos     ; AX = Z*Cos
        add     ebx,eax         ; BX = Y*Sin + Z*Cos = NewZ

        sar     edx,8
        sar     ebx,8
        mov     word ptr [si-4],DX              ; NewY = Y*Cos - Z*Sin
        mov     word ptr [si-2],BX              ; NewZ = Y*Sin + Z*Cos


        loop    @@Loop_Here
        ret
ENDP

RotY    PROC
@@Loop_Here:
        lodsw
        cwde
        mov     ebx,eax
        add     si,2
        lodsw
        cwde
        imul    edx,ebx,Cos
        imul    ebp,eax,Sin
        sub     edx,ebp

        imul    ebx,ebx,Sin
        imul    eax,eax,Cos
        add     ebx,eax

        sar     edx,8
        sar     ebx,8
        mov     word ptr [si-6],DX              ; NewX = X*Cos - Z*Sin
        mov     word ptr [si-2],BX              ; NewZ = X*Sin + Z*Cos


        loop    @@Loop_Here
        ret
ENDP

RotZ    PROC
@@Loop_Here:
        lodsw
        cwde
        mov     ebx,eax
        lodsw
        cwde
        add     si,2
        imul    edx,ebx,Cos
        imul    ebp,eax,Sin
        sub     edx,ebp

        imul    ebx,ebx,Sin
        imul    eax,eax,Cos
        add     ebx,eax

        sar     edx,8
        sar     ebx,8
        mov     word ptr [si-6],DX              ; NewX = X*Cos - Y*Sin
        mov     word ptr [si-4],BX              ; NewY = X*Sin + Y*Cos


        loop    @@Loop_Here
        ret
ENDP

Move    PROC
;        add     si,4
@@Loop_Here:
;        dec     word ptr [si]                  ; Move Left
;        dec     word ptr [si+2]                ; Move Up
;        add     word ptr [si+4],5               ; Move In
        add     si,6
        loop    @@Loop_Here
        ret
ENDP

Move00  PROC
@@Loop_Here:
;        dec     DisX                           ; Move Left
;        dec     DisY                           ; Move Up
        dec     DisZ                            ; Move In
        ret
ENDP

.Code
Start:
        mov     ax,0012h
        int     10h
        mov     di,offset Points
        mov     cx,CantPoints
Loop_1:
        mov     dx,50d
        call    Random
        stosw
        mov     dx,50d
        call    Random
        stosw
        mov     dx,50d
        call    Random
        stosw
        loop    Loop_1
        mov     ax,0a000h
        mov     es,ax
        mov     si,offset Points
        mov     cx,CantPoints
        call    SetUp
Do_It_Again:
        push    cx
        mov     si,offset Points
        mov     cx,CantPoints
        call    Show
        loop    $
;        loop    $
;        loop    $
;        mov     ah,00h
;        int     16h
        mov     si,offset Points
        mov     cx,CantPoints
        call    Clear
        mov     si,offset Points
        mov     cx,CantPoints
;        call    RotX
        mov     si,offset Points
        mov     cx,CantPoints
        call    RotY
        mov     si,offset Points
        mov     cx,CantPoints
        call    RotZ
;        mov     si,offset Points
;        mov     cx,CantPoints
;        call    Move00

        pop     cx
        mov     ah,01h
        int     16h
        jz      Do_It_Again
        mov     ah,00h
        int     16h
        mov     ax,3h
        int     10h
        mov     ax,4c00h
        int     21h
Points  Label   Byte
end     begin


